// DarkSpecter ZX Spectum Emulator
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
// sound driver general vars
//
unit dspEmuSoundU;

interface

uses
  Windows, dspFMU;


var
  EmuSoundDriverPause: procedure (paused: Boolean) = nil;
  EmuSoundFillBuffer: procedure (cs: Integer) = nil;
  EmuSoundFinishFillBuffer: procedure () = nil;
  EmuSoundInit: function (windowH: HWND): Boolean = nil;
  EmuSoundDeinit: procedure () = nil;
  //EmuSoundFlushBuffer: procedure () = nil;


implementation


initialization
  EmuSoundDriverPause := @SoundPause;
  EmuSoundFillBuffer := @SoundFillBuffer;
  EmuSoundFinishFillBuffer := @SoundFinishFillBuffer;
  EmuSoundInit := @SoundInit;
  EmuSoundDeinit := @SoundDeinit;
  //EmuSoundFlushBuffer := @SoundFlushBuffer;
end.
