;(setq lasm_lab *t*)
; 
; :        ()

; : (  - -)

(setq lasm-real-labels *f*)
  ;   -- *f*,     $,   
  ;   -- *t*,    ,   
(setq lasm-labels *nil*)
(setq lasm-last-label *nil*)

(setq lasm-ext-label *nil*)  ;    

(setq lasm-was-addr-label *f*)  ;     ?

(defun lasm-find-label (name | n)
;    
  (if (= (nth name 1) 46) (setq name (|| "0" lasm-last-label name)))
  (for (setq n lasm-labels)
       (land n  (<> name (caar n)))
       (setq n (cdr n))
       ()
  )
  (if n (setq n (car n)))
  n
)

(defun lasm-add-label (name value is-addr extern)
  (if (not lasm-real-labels)
    (begin
      (if (= (nth name 1) 46) (setq name (|| "0" lasm-last-label name))
       (setq lasm-last-label name)
      )
      (if
        (lor (asm-arg-test-literal name) (asm-find-in-oplist lasm-operators name))
          (bad-syntax (|| "invalid label: " name))
        (lasm-find-label lasm-label)
          (bad-syntax (|| "duplicate label: " lasm-label))
       (setq lasm-labels (cons (list name value is-addr extern) lasm-labels))
      )
    )
   (<> (nth name 1) 46) (setq lasm-last-label name)
  )
)

(defun lasm-do-label ()
  (if lasm-label  (lasm-add-label lasm-label asm-pc-st *t*))
)

(defun asm-get-label (name | n)
  (if (= name "$")
    (begin (setq asmexpr-addr *t*) asm-pc-st)
   (begin
     ;(lprintln "searching" name)
     ;(lprintln lasm-labels)
     (setq n (lasm-find-label name))
     (if n
       (begin
         (setq asmexpr-addr (caddr n))
         (if asmexpr-addr (setq lasm-was-addr-label *t*))
         (if (land lasm-ext-label (cadddr n))
             (bad-syntax (|| "second external label in expression: " name))
           (cadddr n) (setq lasm-ext-label (car n))
         )
         ;(lprintln n)
         (cadr n)
       )
      (if lasm-real-labels (bad-syntax (|| "undefined label: " name))
       (begin (setq asmexpr-addr *t*) asm-pc-st)
      )
     )
   )
  )
)
