; save .DMB file
(defun save-mem (fname start len | fh)
  (cond (land (> len 0) (number? (setq fh (fopen fname "c"))))
    (begin
      (setq start (& start $FFFF))
      (fwrite-str fh "DMB0")
      (fwrite-word fh 0)     ; PC
      (fwrite-word fh 1)     ; # of pieces
      (fwrite-word fh len)   ; piece length
      (fwrite-word fh start) ; piece address
      (while (> len 0)
        (fwrite-byte fh (peek start))
        (setq start (& (incr start) $FFFF)  len (decr len))
      )
      (fclose fh)
      (println "memory dump saved.")
    )
   (println "can't create file...")
  )
)
