// DarkSpecter ZX Spectum Emulator
// coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
// Understanding is not required. Only obedience.
//
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar. See
// http://sam.zoy.org/wtfpl/COPYING for more details.
//
unit win32U;

interface

uses
  Windows, SysUtils;


function IsSpecialFile (const fName: string): Boolean;


implementation


function IsSpecialFile (const fName: string): Boolean;
var
  hd: Integer;
begin
  result := true;
  if fName = '' then exit;
  if not FileExists(fName) then
  begin
    // no such file, try to create one
    hd := Windows.CreateFile(PChar(fName), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil,
      OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
    if hd = -1 then exit; // not a device, not a file
    CloseHandle(hd);
    if not FileExists(fName) then exit; // a device
    DeleteFile(fName);
  end;
  result := false;
end;


end.
